-- DISPLAY
-- Head-up display for the randomization

-- K_StringWidth
-- Returns the width of the string if it were drawn as a kart string (v.drawKartString). Idk if it exists...
-- Only accepts uppercase.
local function K_StringWidth(str)
	local result = 0
	
	for i = 1, string.len(str) do
		if string.sub(str, i, i) == "I" or string.sub(str, i, i) == ":" then result = $+8
		elseif string.sub(str, i, i) == "M" then result = $+15
		elseif string.sub(str, i, i) == "N" then result = $+13
		elseif string.sub(str, i, i) == "W" then result = $+17
		else result = $+12 end
	end
	return result
end

hud.add(function(v, player)
	if not player.cloneFighter then return end
	
	-- Stats
	
	local x, y, f, ff = 5, 160, "left", V_SNAPTOLEFT
	
	if displayplayers[2] then
		x, y, f = 2, 2, "thin"
		if player == displayplayers[1] or player == displayplayers[3] then
			x, f, ff = 318, "thin-right", V_SNAPTORIGHT
		end
		if player == displayplayers[2] or player == displayplayers[3] then
			y = 102
		end
		
		if player.kartstuff[k_itemroulette] or player.kartstuff[k_itemtype]
		or player.kartstuff[k_stolentimer] or player.kartstuff[k_eggmanexplode] then
			y = $+25
		end
	elseif displayplayers[1] and player == displayplayers[0] then
		y = 60
	elseif player == displayplayers[0]
		y = 156
	end
	
	if player.cfSkin and (not displayplayers[2]
	or leveltime > 9*TICRATE/2 or ((player.prefSpeed != nil or player.prefWeight != nil) and leveltime > 3*TICRATE)) then
		if player.cfSkin == "undefined" then
			v.drawString(x, y, "UNDEFINED", ff|V_REDMAP, f)
		else
			v.drawString(x, y, skins[player.cfSkin].realname, ff|V_ALLOWLOWERCASE, f)
		end
		local swstr = ""
		if player.prefSpeed and player.cfSpeed == player.prefSpeed then
			swstr = "\x83"
		end
		swstr = $..player.cfSpeed.."\x80 / "
		if player.prefWeight and player.cfWeight == player.prefWeight then
			swstr = $.."\x83"
		end
		swstr = $..player.cfWeight
		v.drawString(x, y+8, swstr, ff, f)
	elseif not displayplayers[2] then
		v.drawString(x, y, "???????", ff, f)
		v.drawString(x, y+8, "? / ?", ff, f)
	end
	x, y, f, ff = nil
	
	-- Randomizer
	if leveltime > 9*TICRATE/2
	or ((player.prefSpeed != nil or player.prefWeight != nil) and leveltime > 3*TICRATE) then return end
	
	x, y, f, ff = 144, 48, "left", 0
	local xx = 160
	if displayplayers[2] then
		x, y, f, ff = 2, 2, "thin", V_SNAPTOLEFT
		if player == displayplayers[1] or player == displayplayers[3] then
			x, f, ff = 318, "thin-right", V_SNAPTORIGHT
		end
		if player == displayplayers[2] or player == displayplayers[3] then
			y = 102
		end
	elseif displayplayers[1] then
		if player == displayplayers[0] then
			y = 10
		else
			y = 110
		end
	end
	
	if player.cfSkin then
		if leveltime % 2 == 0 or leveltime >= 3*TICRATE or ((player.prefSpeed or player.prefWeight) and leveltime >= 5+TICRATE/2)
			if displayplayers[2] then
				local uf = (player.cfSkin == "undefined") and V_REDMAP or 0
				local str = uf and "UNDEFINED" or skins[player.cfSkin].realname
				v.drawString(x, y+16, str, V_ALLOWLOWERCASE|uf|ff, f)
				local sF = (player.prefSpeed and player.prefSpeed > 0) and V_GREENMAP or 0
				local sS = "Speed: "..tostring(player.cfSpeed)
				v.drawString(x, y+24, sS, V_ALLOWLOWERCASE|sF|ff, f)
				local wF = (player.prefWeight and player.prefWeight > 0) and V_GREENMAP or 0
				local wS = "Weight: "..tostring(player.cfWeight)
				v.drawString(x, y+32, wS, V_ALLOWLOWERCASE|wF|ff, f)
				
				if x == 318 then x = $-16 end
				local skin = (not uf) and player.cfSkin or "clonefighter"
				local gr = v.cachePatch(skins[skin].facerank)
				local c = v.getColormap(TC_RAINBOW, player.skincolor)
				v.draw(x, y, gr, ff, c)
			else
				if not displayplayers[1] then
					v.drawString(xx-(v.stringWidth("Your skin for this race is")/2), y+40, "Your skin for this race is", V_ALLOWLOWERCASE)
				else y = $-8 end
				
				if player.cfSkin != "undefined" then
					v.drawKartString(xx - (K_StringWidth(string.upper(skins[player.cfSkin].realname))/2), y+48,
									 string.upper(skins[player.cfSkin].realname))
				else
					v.drawString(xx-(v.stringWidth("...undefined...")/2), y+48, "...undefined...", V_ALLOWLOWERCASE|V_REDMAP)
				end
				
				local sF = (player.prefSpeed and player.prefSpeed > 0) and V_GREENMAP or 0
				local sS = sF and "Speed: "..tostring(player.cfSpeed).." (preferred)" or "Speed: "..tostring(player.cfSpeed)
				v.drawString(xx-(v.stringWidth(sS)/2), y+64, sS, V_ALLOWLOWERCASE|sF)
				local wF = (player.prefWeight and player.prefWeight > 0) and V_GREENMAP or 0
				local wS = wF and "Weight: "..tostring(player.cfWeight).." (preferred)" or "Weight: "..tostring(player.cfWeight)
				v.drawString(xx-(v.stringWidth(wS)/2), y+72, wS, V_ALLOWLOWERCASE|wF)
				
				if displayplayers[1] then y = $+8 end
				local skin = (player.cfSkin != "undefined") and player.cfSkin or "clonefighter"
				local gr = v.cachePatch(skins[skin].facewant)
				local c = v.getColormap(TC_RAINBOW, player.skincolor)
				v.draw(x, 8*sin(leveltime*ANG2)/FRACUNIT + y, gr, 0, c)
			end
		end
	else
		local wait = "Please wait"
		if leveltime % 70 >= 17 then
			wait = $.."."
		end
		if leveltime % 70 >= 35 then
			wait = $.."."
		end
		if leveltime % 70 >= 52 then
			wait = $.."."
		end
		v.drawString(xx-(v.stringWidth("Please wait...")/2), y+40, wait, V_ALLOWLOWERCASE)
		
		local skin = player.randomskin or "clonefighter"
		if displayplayers[2] then
			if x == 318 then x = $-16 end
			local gr = v.cachePatch(skins[skin].facerank)
			local c = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
			v.draw(x, y, gr, ff, c)
		else
			local gr = v.cachePatch(skins[skin].facewant)
			local c = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
			v.draw(x, 8*sin(leveltime*ANG2)/FRACUNIT + y, gr, 0, c)
		end
	end
end)